import sys,os,math 
import kivy
from kivy import platform

#kivy.require('1.9.0')
from kivy.app import App
from kivy.uix.boxlayout import BoxLayout
from kivy.properties import BooleanProperty, ListProperty, ObjectProperty,NumericProperty
from kivy.lang import Builder
from kivy.uix.recycleview import RecycleView

from kivy.uix.recycleview.views import RecycleDataViewBehavior
from kivy.uix.button import Button
from kivy.uix.recyclegridlayout import RecycleGridLayout
from kivy.uix.behaviors import FocusBehavior
from kivy.uix.recycleview.layout import LayoutSelectionBehavior
from kivy.uix.popup import Popup
from kivy.core.window import Window
#Window.size = (600, 325)
from kivy.clock import Clock

class EditFileChooser(BoxLayout):
	load = ObjectProperty(None)
	cancel = ObjectProperty(None)



class ListFileChooser(BoxLayout):
	load = ObjectProperty(None)
	cancel = ObjectProperty(None)



class SelectableRecycleGridLayout(FocusBehavior, LayoutSelectionBehavior,
								  RecycleGridLayout):
	''' Adds selection and focus behaviour to the view. '''


class SelectableButton(RecycleDataViewBehavior, Button):
	''' Add selection support to the Button '''
#	index = None
	selected = BooleanProperty(False)
	selectable = BooleanProperty(True)
	rv_data = ObjectProperty(None)
	start_point = NumericProperty(0)
	col_data = ListProperty(["?", "?"])
	index = NumericProperty(0)
	selectedItem=None


	def __init__(self, **kwargs):
		super(SelectableButton, self).__init__(**kwargs)
		Clock.schedule_interval(self.update, .0005)



	def update(self, *args):
		self.text = self.rv_data[self.index][self.key]

	def refresh_view_attrs(self, rv, index, data):
		''' Catch and handle the view changes '''
		self.index = index
		return super(SelectableButton, self).refresh_view_attrs(rv, index, data)

	def on_touch_down(self, touch):
		''' Add selection on touch down '''
		if super(SelectableButton, self).on_touch_down(touch):
			return True
		if self.collide_point(*touch.pos) and self.selectable:
			return self.parent.select_with_touch(self.index, touch)

	def apply_selection(self, rv, index, is_selected):
		self.selected = is_selected
		self.rv_data = rv.data

	def on_press(self):
	#	self.index = obj.index
#		self.col_data[0] = obj.rv_data[self.index]["Id"]
#		self.col_data[1] = obj.rv_data[self.index]["Name"]
		self.col_data[0] = self.rv_data[self.index]["Name"]
		SelectableButton.selectedItem = self.index
		print("第(",SelectableButton.selectedItem,")项内容[",self.col_data[0],"]已选中")
#		pass
	  #  popup = EditStatePopup(self)
	   # popup.open()
		return SelectableButton.selectedItem

class MyRV(RecycleView):
	def __init__(self, **kwargs):
		super(MyRV, self).__init__(**kwargs)
		self._keyboard = Window.request_keyboard(self._keyboard_closed, self)
		self._keyboard.bind(on_key_down=self._on_keyboard_down)
		self.selectedItem = -1

	def _keyboard_closed(self):
		pass

	def _on_keyboard_down(self, keyboard, keycode, text, modifiers):
		if keycode[1] == 'down':
			self.clearAll()
			self.nextItem()
			print('down')
		elif keycode[1] == 'up':
			self.clearAll()
			self.prevItem()
			print("up")
		#elif keycode[1] == 'e' and len(modifiers) > 0 and modifiers[0] == 'ctrl':
		#	self.view_adapter.views[self.selectedItem].on_press()

	def clearAll(self):
		if (self.selectedItem > -1):
			for i in range(len(self.view_adapter.views) - 1):
				self.view_adapter.views[self.selectedItem].selected = 0


	def nextItem(self):
		if self.selectedItem < len(self.view_adapter.views) - 1:
			self.selectedItem += 1
		else:
			self.selectedItem = 0
		self.view_adapter.views[self.selectedItem].selected = 1
		#print(self.selectedItem)
		print("第[",self.selectedItem,"]项已选中")


	def prevItem(self):
		if self.selectedItem > 0:
			self.selectedItem -= 1
		else:
			self.selectedItem = len(self.view_adapter.views) - 1
		self.view_adapter.views[self.selectedItem].selected = 1
		print("第[",self.selectedItem,"]项已选中")



class RV (RecycleView):
	fileName_choose=""#全局变量
	Ignore=0 #兼容如意软件变量，此版因为考虑python及C等编程语言模式，数字括号设为第2，3位，如意是第1，2位
	PicSize=600
	FormatShow=False
	IdxFrom=2
	AppendP=False#v0.991新增，判断摘录的追加模式，还是插入模式（改为默认），这是次较大的变动
	KeyWordStr=""#v0.981新增
	KeyWordStr2=""#v0.987新增
	IndexLogFile="IndexLog.txt"
	LastKey=""
	noun=[]
	Adverb=[]
	Verb=[]
	Verb1=[]#v0.986新增
	KeyTitle="笈智关键字"
	FFname=""
	NOpIdx=[]
	ViewList=[]
	AutoMode=False
	Expdic={}
	ExpMode=False
	Doing=1#0414v0.992
#	RedoList=[]
	Expitem=-1
	Expbnow=0
	Expfnow=0
	Expbackstep=0
	Expforestep=0
	FullStep=0
	lViewList=0
	MyOutput=""
	CheckedRowNuber=[]
	JustNum=-1
	mystr=""
	PosFound=-1
	numt1=["","","","",""]
	numt1id=[0,0,0,0,0]
	fmt=3
	PMark='♢'
	JMark='♡'
	promptstr1="特殊字符：☯图片⌇续行♢分页♡链接"
	OftenFiles="oftenfiles.set"#目录文件名
	FruitFile="Fruit.txt"#搜索结果文件名
	IndexFile="Fruit.idx"#搜索结果索引文件名
	KruleFile="Krule.txt"#关键词解析词源文件名
	KwdFile="Kwd.txt"		#文本框排除法解析关键词追加的结果文件
	_startPos = None
	_endPos = None
	_isTracking = False
	Model =[]
	prompstr="点下边目录行，再点上方[^]按钮可打开内容页。★笈智1.0kv★QQ625052847讨论群869383760"#顶行（本行）为输入行，双击后可输入关键字，点[搜索]按钮可进行内容搜索，'与条件'关键字由';'分隔，'或条件'由空格或'、'分隔，精确数字匹配在第一个字输入'｀'。点中顶行，再勾选顶行，可勾选全页，再勾选一次可取消全选；点[摘录]按钮，勾选内容会显示到右栏；点[计算]按钮可计算点中行算式，结果显示在顶行。20030611注释即软件，软件即注释，用活好典籍，笈智当第一  本款为图形界面v1.0p版，希望老少朋友们喜欢，家有爱编程萌宝的可用来仿作编程哦，本软件是人工智能的平民化定义。勾选本行，可显示注释行，本软件可广泛应用于医学、工程、编程、法律、教育、行政等领域，。本软件是自由软件，遵循GPL v3.0许可，详见http://www.gnu.org/licenses/quick-guide-gplv3.html，您可以带源代码再发布（包括要求有偿），但没有担保。" 


	data_items = ListProperty([])
	col1 = ListProperty()
	col2 = ListProperty()

	def __init__(self, **kwargs):
		super(RV, self).__init__(**kwargs)

		self.cwd = os.getcwd() # 获取当前程序文件位置
		self.init_others()#界面的其它初始化，包括文件方法等

		self.QtSetmodel(self.Model)#get_states()

	def QtStandardItemModel(self):#update(self):
		#self.col1 = [{'Id': str(x[0]), 'Name': x[1], 'key': 'Id', 'text': str(x[2])} for x in self.data_items]
		#self.col2 = [{'Id': str(x[0]), 'Name': x[1], 'key': 'Name', 'text': str(x[2])} for x in self.data_items]
		self.col2=[]
		print(self.data_items)
		self.col2 = [{'Name': x[0], 'key': 'Name', 'text': str(x[1])} for x in self.data_items]


	def QtSetmodel(self,Model):#get_states(self):
		lM=len(Model)
		rows = []# [(1, 'Test1'), (2, 'Test2'), (3, 'Test3'), (4, 'Test4')]
		for j in range(lM): 
		#	print(j+1)
	#		linc=[]
			#linc.append(j+1)
	#		linc.append(Model[j])#+str(j+1))
			rows.append(Model[j])#linc)
		i = 0
		self.data_items=[]
		for row in rows:
			self.data_items.append([row,i])#[row[0],  i])
#			print(row[0],  i)
			i += 1
		self.QtStandardItemModel()#update()



	def init_others(self):#界面的其它初始化，包括文件方法等
#		self.myfileopen("",2)
		self.myfileopen(self.OftenFiles,1)

	def myfileopen (self,slecstr,n): #文件打开准备20230203
#		print("\n进入myfileopen->",n,"新开文件名： ",slecstr)
	#	localtime=self.Ztime(0)
	#	print("当地时间为：",localtime)
		KFP=False#打开关键字文件判断
		FKP=False#文件中是否自带关键字判断
		LineScope=50#关键字不超过50行，若有需要可修改此数字
		#if(len(self.noun)<2):###0426 
		mypath=os.path.join(os.getcwd(),self.KruleFile)#读取文件Krule.txt中的名词、前缀、后缀、单字白名单
		if(os.path.isfile(mypath)):
			fh=open(mypath,mode='r+t',encoding='UTF-8')
			if fh:
				fh.close
				self.KeyListInit(mypath,0)
				KFP=True
		if(slecstr.strip()):		
			if(slecstr.find(self.OftenFiles)<=0):#如果不是第一次打开，或不是回主页界面操作
				fh=open(slecstr,mode='r+t',encoding='UTF-8')
				if fh:
					fh.seek(0)
					data=fh.read()
					print("完成打开文件->",slecstr)
					fh.close()
					mylist = data.split("\n")
					lm=len(mylist)
					i1=0
					for i in range(lm-1,0,-1):
						if(i1<LineScope):
							if(mylist[i].find(self.KeyTitle)>=0):#发现“笈智关键字”字串
								line=i
								print("\t\tmyfileopen 模块倒查至(",i,")行，发现笈智关键字格式")
								self.KeyListInit(slecstr,line)
								FKP=True
								break
						else:
							print("\t\tmyfileopen 模块倒查至(",i,")行，已至边界行数(",LineScope,")，未发现笈智关键字格式")
							break
						i1+=1
		if((not KFP) and (not FKP)):
			self.WKrule()

		ExpMode=False
		mypath=os.path.join(os.getcwd(),self.OftenFiles)
		fh=False
	#	model=QStandardItemModel()#KV0611
		if(slecstr.strip()):		
			fh=open(slecstr,mode='a+t',encoding='UTF-8')
			self.KeyWordStr=""#0225v0.981
			self.KeyWordStr2=""#0225v0.981
#			print("\t全局变量关键词清空")
			#if not fh:
			#	fh=open(mypath,mode='r',encoding='UTF-8')
		else:
			if(n==2):
				if(not self.fileName_choose.strip()):
					print("首次打开……")
					self.fileName_choose=mypath#v0.60-
			#		picname='微信打赏.jpg'
			#		item = QStandardItem("欢迎随宜打赏，QQ625052847。"+self.promptstr1)
					#item.setCheckState(False)
					#item.setCheckable(True)
			#		model.clear()
			#		model.appendRow(item)						
			#		model.item(0).setIcon(QIcon(os.path.join(os.getcwd(),"sty",'笈智互助群.png')))#picname 搜笈互助群.png
			#		self.ui.listView_2.setIconSize(QSize(250,250))#300,300
					#self.ui.textEdit.append("<img src=\"file://"+os.path.join(os.getcwd(),"sty",picname)+"\" width=\"280\">")#for Ubuntu 20230203
			#		self.ui.textEdit.append("<img src=\""+os.path.join(os.getcwd(),"sty",picname)+"\" width=\"280\">")#for windows 20230203'搜笈互助群.png'
		if fh:
			fh.seek(0)
			data=fh.read()
			print("完成打开文件->",slecstr)
#			print("<-。文件字符：\n",data)
			fh.close()
			mylist = data.split("\n")
			self.Ignore=self.DLFmt(mylist)#v0.89 0406
	#		model = QStandardItemModel()
			lie=mylist[0].split()
			lcol=len(lie)
			if(lcol>=2):
				if(lie[self.Ignore+1][-1]=='0' and lie[self.Ignore+2].isdigit()):
					self.ExpMode=True
					self.lViewList=len(mylist)
					self.ViewList=mylist
					self.Expbackstep=0
					self.Expforestep=int(lie[self.Ignore+2])
					self.Expbnow=0#V0.75
					self.Expfnow=0
					print(slecstr,"判断为专用模式文件！")
					print("文件初打开，回跳位置",self.Expbnow,"回跳步长：",self.Expbackstep,"前跳位置",self.Expfnow,"前跳步长：",self.Expforestep)		
				else:
					self.ExpMode=False
					print(slecstr,"判断为非专用模式文件！")
			else:
				self.ExpMode=False
				self.ViewList=mylist#20230307
				self.lViewList=len(mylist)#20230307
				print(slecstr,"为非专用模式文件！")#ViewList[0]为：",self.ViewList[0]20230307

			i=0
			i1=0#格式行
			if not self.ExpMode:#非专用文件
				for task in mylist:
					#print("i=",i,",i1=",i1)
					if(self.fileName_choose==mypath):#当打开oftenfiles.set文件时
						lstr=os.path.split(task)[1]#忽略路径，只取文件名，成文库目录
						item =lstr #KV0611 QStandardItem(lstr)
		#				item.setCheckState(False)
		#				item.setCheckable(True)
					else:	
						item =task #KV0611  QStandardItem(task)
		#				item.setCheckState(False)
		#				item.setCheckable(True)
					if i == 0 :
						item1 = self.prompstr #KV0611 QStandardItem(self.prompstr)
		#				item1.setCheckState(False)
		#				item1.setCheckable(True)
						model=[] #KV0611 model.clear()
						model.append(item1) #KV0611 appendRow(item1)
						model.append(item) #KV0611 appendRow(item)
					else:
						model.append(item) #KV0611 appendRow(item)
		#				if task.strip(): #v0.56插入图片☯xx.jpg
		#					if (task[0]=='☯') :
		#						picname=os.path.join("sty",task[1:]+".jpg")
		#						model.item(i+1).setIcon(QIcon(picname))
		#						if(n==1):
		#							self.ui.listView.setIconSize(QSize(self.PicSize,self.PicSize))
		#						if(n==2):
		#							self.ui.listView_2.setIconSize(QSize(self.PicSize,self.PicSize))
					i=i+1
			else:#Expert mode专用文件
				for task in mylist:
					#print("\n\t2023task",task)
					if(self.fileName_choose==mypath):#打开oftenfiles.set设置文件时
						lstr=os.path.split(task)[1]#取文件的名
						item =lstr #KV0611  QStandardItem(lstr)
		#				item.setCheckState(False)
		#				item.setCheckable(True)
					else:	
						if(i==i1):#v0.73打开其它文件时，格式空置显示
							if self.FormatShow:
								item = self.ViewList[i] #KV0611  QStandardItem(self.ViewList[i])
							else:
								item = ""#QStandardItem("")

						else:
							item = task #QStandardItem(task)
		#				item.setCheckState(False)
		#				item.setCheckable(True)

					if i == 0 :#首页首项显示提示
						item1 = self.prompstr #QStandardItem(self.prompstr)
		#				item1.setCheckState(False)
		#				item1.setCheckable(True)
						model=[] #.clear()
						model.append(item1)#.appendRow(item1)#兼容模式首页多此一行
	
						if(i==i1):#v0.73格式行
							if(i<self.lViewList-2):
								lie=mylist[i1].split()
								if(self.Ignore+2<len(lie)):
									i1=i+int(lie[self.Ignore+2])+1#定位下一个格式行
#									print("\t兼容首页当前格式行i=",i,",下一个格式行i1=",i1)
						model.append(item)#appendRow(item)
					else:#i!=0兼容模式非首页首项
						if(i==i1):#v0.73
							if(i<self.lViewList-2):
								lie=mylist[i1].split()
								if(self.Ignore+2<len(lie)):
									if(lie[self.Ignore+2].isdigit()):
										i1=i+int(lie[self.Ignore+2])+1
										#print("\t当前格式行i=",i,",下一个格式行i1=",i1)
									else:
										print("\t当前行i=",i,"非格式行错误，请予以修正")
						model.append(item)#appendRow(item)
					i=i+1

		if(model):
			if(n==1):
				self.Model=model
#				self.ui.listView.setModel(self.model)
				self.QtSetmodel(self.Model)#get_states()

		self.NOpIdx=[]#v0.76清空多选项表
#		self.show()



	def Ztime (self,n):#电脑中文当地时间，n为整数，0为年月时分秒，1为年月时分，2为月日时分，3为日时分，4为时分
		timet=time.localtime(time.time())
		if(n==0):
			localtime=time.strftime("%Y-%m-%d-%H:%M:%S",timet)
		elif(n==1):
			localtime=time.strftime("%Y-%m-%d-%H:%M",timet)
		elif(n==2):
			localtime=time.strftime("%m-%d-%H:%M",timet)
		elif(n==3):
			localtime=time.strftime("%d-%H:%M",timet)
		elif(n==4):
			localtime=time.strftime("%H:%M%",timet)
#		self.LocalTime=localtime
	#	print("\t\t当地时间为：",localtime)
		return localtime


	
	def KeyListInit (self,mypath,line):#关键字初始化，从文件某行开始读入赋值
		#mypath=os.path.join(os.getcwd(),self.KruleFile)#读取文件Krule.txt中的名词、前缀、后缀、单字白名单
		fh=open(mypath,mode='r',encoding='UTF-8')
		if fh:
			fh.seek(0)
			data=fh.read()
#			print("完成打开文件->",mypath)
			fh.close()
			mylist = data.split("\n")
			lm=len(mylist)
			strt=""
			cn=0
			Adverb=[]
			noun=[]
			Verb=[]
			Verb1=[]
			for i1 in range(line+1,lm):
				PassP=True
#				print(i1,"行内容[",mylist[i1],"]")
				if(len(mylist[i1])>0):
					if(mylist[i1][0]=='#'):
						if(len(strt)>0):
							if(cn==1):
								list1=strt.split()
								strt=""
							elif(cn==2):
								list2=strt.split()
								noun.append(list1)
								noun.append(list2)
#								print("\t\tnoun表为：",noun)
								strt=""
							elif(cn==3):
								Adverb=strt.split()
								strt=""
#								print("\t\tAdverb表为：",Adverb)
							elif(cn==4):
								Verb=strt.split()
								strt=""
#								print("\t\tVerb表为：",Verb)
							elif(cn==5):
								Verb1=strt.split()
								strt=""
#								print("\t\tVerb1表为：",Verb1)
						cn+=1
						PassP=False
					if PassP:
						strt+=mylist[i1]
#						print("\t\t联结字串成为[",strt,"]")#结束读取文件Krule.txt中的名词、前缀、后缀、单字白名单
			self.Adverb=Adverb
			self.noun=noun
			self.Verb=Verb
			self.Verb1=Verb1



	def WKrule (self):#如果没有关键字文件，默认从伤寒论关键字，创建该文件##v0.997 0426   
		noun=[['脉', '风', '热', '表', '里', '汗', '头', '面', '目', '口', '鼻', '咽','喉', '身', '体', '项', '背', '腰', '胸', '胁', '膈', '心', '腹', '脐', '脚', '手', '足', '脾', '胃', '肠', '针', '利', '疟', '胁', '饥', '水', '饮', '气', '血', '荣', '卫', '昼', '夜', '寸', '关', '尺', '衣', '床', '食', '噫', '眠', '睡', '静', '谐', '矢', '喘', '疮', '声', '语', '脓', '漏', '精', '色', '产', '经', '妇', '劳', '痉'], ['太阳', '膀胱', '四肢', '小便', '大便', '阳明', '骨节', '清谷', '日晡', '潮热', '骨节', '奔豚', '手足','妊娠']] 
		Adverb= ['不', '无', '有', '未', '可', '多', '少', '大', '小', '嗜', '喜', '恶', '怕', '发', '自', '捻', '摸', '谵', '得', '干', '似', '欲', '结', '潮', '昏', '半', '遂', '乍', '或', '在', '能', '谵', '必', '入', '即', '饮', '善', '而', '唾', '冲', '生', '时', '切', '失'] 
		Verb= ['浮', '弦', '涩', '弱', '微', '细', '缓', '紧', '洪', '大', '促', '迟', '沉', '滑', '短', '出', '臭', '吐', '厥', '逆', '鸣', '痛', '疼', '强', '咳', '漏', '难', '屈', '伸', '痒', '烦', '躁', '引', '寒', '如', '伤', '挛', '急', '温', '伸', '止', '胀', '满', '卧', '轻', '重', '解', '渴', '噎', '呕', '瞑', '衄', '悸', '和', '清', '往', '来', '眩', '懊', '恼', '窒', '结', '溏', '挛', '疟', '言', '动', '燥', '淋', '疮', '苦', '哕', '鞕', '惊', '狂', '灼', '中', '烂', '发', '扰', '竭', '数', '则枯', '利', '冷', '痞', '几', '安', '赤', '彻', '度', '虚', '实', '黄', '休', '上', '下', '反', '仁', '黑'] 
		Verb1=['苦','哕','咳', '呕', '吐', '烦', '渴', '噎', '窒', '漏', '淋', '瞑', '衄', '悸', '下', '利', '重', '眩', '鸣']
		Exclud=['，', '。', '；', '、', '：', '一', '二', '三', '四', '五', '六', '七', '八', '九', '十', '日', '则', '以', '此', '必', '之', '了', '者', '也', '而', '于', '甚', '或', '和', '与', '并', '反', '不', '可', '宜', '故', '未', '再', '无', '难', '前', '后', '去', '更', '名', '为', '传', '得', '色', '方', '法', '加', '攻', '其', '复', '煮', '取', '症', '调', '以', '愈', '治', '针', '误', '在', '滓', '亦', '何', '仍', '坏', '用', '几', '衣', '服', '作', '家', '至', '曰', '草', '桂', '枝', '姜', '枣', '愈', '治', '药', '液', '枯', '酒', '客', '附', '子', '升', '两', '斤', '证', '已', '若', '被', '汤', '闻', '主', '欲', '解', '半', '夏', '承', '虎', '麻', '人', '皮', '太', '明', '甘', '伤', '旦', '（', '）', '(', ')', 'n', '\\n', '苓', '散', '卷', '忄', '吴', '所', '蒿', '理', '假', '令', '卫', '当', '归', '猪', '连', '芩', '尺', '中', '寸', '关', '自', '少', '桃', '仁', '消', '谷', '时', '茯', '术', '因', '朴', '邪', '枳', '翁', '龙', '牡', '泽', '嘿', '桔', '梗', '本', '芪', '葛', '根', '阿', '胶', '刺', '泻', '豆', '知', '犯', '杏', '仁', '久', '须', '茱', '茵', '救', '陈', '令', '乌', '是', '因', '致', '先', '刺', '柴', '胡', '汁', '蜜', '煎', '虽', '愦', '但', '文', '蛤', '乍', '真', '武', '荣', '禹', '熏', '余', '粮', '见', '陷', '雷', '合', '地', '石', '膏', '青', '从', '凡', '血', '分', '医', '瓜', '蒂', '期', '门', '悉', '津', '行', '除', '栝', '蒌', '建', '诸', '言', '属', '浆', '灸', '病', '辛', '死', '参', '脏', '芍', '今', '栀', '乃', '过', '丸', '问', '还', '彻', '厚', '辨', '续', '罢', '豉', '萸', '使', '师', '蛎', '丑', '橘', '枚', '斗', '柏']
		self.noun=noun
		self.Adverb=Adverb
		self.Verb=Verb
		self.Verb1=Verb1
		mypath=os.path.join(os.getcwd(),self.KruleFile)#名词、前缀、后缀、单字白名单写入文件Krule.txt中的
		fh=open(mypath,mode='w+t',encoding='UTF-8')
		if fh:
			lm=len(noun[0])
			fh.write("#笈智关键字"+"\n")
			fh.write("#单字名词"+"\n")
			for i in range(lm-1):
				fh.write(noun[0][i]+"  ")
				if(i%20==19):
					fh.write("\n")
			fh.write(noun[0][lm-1]+"\n")

			lm=len(noun[1])
			fh.write("#双字名词"+"\n")
			for i in range(lm-1):
				fh.write(noun[1][i]+"  ")
				if(i%20==15):
					fh.write("\n")
			fh.write(noun[1][lm-1]+"\n")

			lm=len(Adverb)
			fh.write("#前缀"+"\n")
			for i in range(lm-1):
				fh.write(Adverb[i]+"  ")
				if(i%20==19):
					fh.write("\n")
			fh.write(Adverb[lm-1]+"\n")

			lm=len(Verb)
			fh.write("#后缀"+"\n")
			for i in range(lm-1):
				fh.write(Verb[i]+"  ")
				if(i%20==19):
					fh.write("\n")
			fh.write(Verb[lm-1]+"\n")

			lm=len(Verb1)
			fh.write("#单字后缀白名单"+"\n")
			for i in range(lm-1):
				fh.write(Verb1[i]+"  ")
				if(i%20==19):
					fh.write("\n")
			fh.write(Verb1[lm-1]+"\n")


			lm=len(Exclud)
			fh.write("#关键字黑名单"+"\n")
			for i in range(lm-1):
				fh.write(Exclud[i]+"  ")
				if(i%20==19):
					fh.write("\n")
			fh.write(Exclud[lm-1]+"\n")

			fh.close
		


	def DLFmt (self,mylist):#数字括号前缀项位数，设定全局变量Ignore #0421
		Ignore=0 #print("进入数字括号项数判定模块")
#		mylist=datastr.split('\n')
		lie=mylist[0].split()
		ll=len(lie)
		if(ll>=2):
		#	print("首项转成列表：\t",lie)
			i1=0
			for lstr in lie:#判断数字括号格式项序号
				if(i1<=ll-1):
		#			print("列项末符：",lstr[-1])
					if(lstr[-1]=='0'):
						if(lie[i1+1].isdigit()):
							Ignore=i1-1#self.Ignore=i1-1 20230406
#							print("格式项self.Ignore=",self.Ignore)
							break
				i1+=1
		return Ignore



class MainApp(App,RV):


	title = "Jzkv"
	FFname = ""
	QtMessageOk = False
	selectedItem = -1


	def EditFileOpen (self):#格式文件操作FFopen() show_load(self):
		#loadfile=ObjectProperty(None)
		HomeDir = None
		if platform == 'win':
			HomeDir = os.environ["HOMEPATH"]
		elif platform == 'android':
			HomeDir = os.path.dirname(os.path.abspath(__file__))
		elif platform ==  'linux':
			HomeDir = os.environ["HOME"]
		print("文件选择的主目录为[",HomeDir,"]")
		EditFileChooser.path=HomeDir
		content1 =EditFileChooser(load=self.EditFileLoad,cancel=self.dismiss_popup)#_popup.dismiss)#
		self._popup = Popup(title='选择文件',content=content1)#, size_hint(0.9,0.9))
		self._popup.open()


			
	def ListFileOpen (self):#格式文件操作FFopen() show_load(self):
		#loadfile=ObjectProperty(None)
		content1 =ListFileChooser(load=self.ListFileLoad,cancel=self.dismiss_popup)#_popup.dismiss)#
		self._popup = Popup(title='选择文件',content=content1)#, size_hint(0.9,0.9))
		self._popup.open()


			
	def dismiss_popup(self):
		self._popup.dismiss()



	def EditFileLoad(self,path,filename):#):#
	#	print("获取文件路径：{",path,"}，文件名{",filename,"}")
#		self.fbrowser = kivy.garden.filebrowser.FileBrowser(select_string='Select',
#			multiselect=False,#True,#
#			filters=['*.*'],path=HomeDir)

		locFname =filename[0] #文件名为表，取第一项 os.path.join(path,filename)
#		print("获取文件字串[",locFname,"]")
		filet=self.FFname
		data=self.root.ids['Text_Edit'].text #0604 kv重写获取编辑框输入
	#	print("获取编辑框字串[",data,"]")
		if(len(data)==0):#(not filet.strip()):#编辑框无字符，打开文件，准备编辑
			if(os.path.exists(locFname)):
				fh=open(locFname,mode='r+t',encoding='UTF-8')
				if fh:
	#				print("编辑框为空，文件『",locFname,"』正常打开")
					fh.seek(0)#注意读取文件时候要将文件指针指向第一个
					data=fh.read()
					fh.close()
					mylist = data.split("\n")
					for ss in mylist:
						#self.ui.textEdit.append(ss)#v0.76
						self.root.ids['Text_Edit'].text += ss
					self.FFname=locFname
	#			else:
	#				print("文件『",locFname,"』未正常打开")

		else:#编辑框有字符，看是否已有此文件，准备覆盖更新
			if(os.path.exists(locFname)):
	#			print("编辑框不空，覆盖写入『",locFname,"』。")
				fh=open(locFname,mode='w+t',encoding='UTF-8')
				if fh:
					fh.write(data)
					fh.close()	#20230203
		self._popup.dismiss()



	def ListFileLoad(self,path,filename):#):#
	#	print("获取文件路径：{",path,"}，文件名{",filename,"}")
#		self.fbrowser = kivy.garden.filebrowser.FileBrowser(select_string='Select',
#			multiselect=False,#True,#
#			filters=['*.*'],path=HomeDir)

		locFname =filename[0] #文件名为表，取第一项 os.path.join(path,filename)
#		print("获取文件字串[",locFname,"]")
		filet=self.FFname
		data=self.root.ids['Text_Edit'].text #0604 kv重写获取编辑框输入
	#	print("获取编辑框字串[",data,"]")
		if(len(data)==0):#(not filet.strip()):#编辑框无字符，打开文件，准备编辑
			if(os.path.exists(locFname)):
				fh=open(locFname,mode='r+t',encoding='UTF-8')
				if fh:
	#				print("编辑框为空，文件『",locFname,"』正常打开")
					fh.seek(0)#注意读取文件时候要将文件指针指向第一个
					data=fh.read()
					fh.close()
					mylist = data.split("\n")
					for ss in mylist:
						#self.ui.textEdit.append(ss)#v0.76
						self.root.ids['Text_Edit'].text += ss
					self.FFname=locFname
	#			else:
	#				print("文件『",locFname,"』未正常打开")

		else:#编辑框有字符，看是否已有此文件，准备覆盖更新
			if(os.path.exists(locFname)):
	#			print("编辑框不空，覆盖写入『",locFname,"』。")
				fh=open(locFname,mode='w+t',encoding='UTF-8')
				if fh:
					fh.write(data)
					fh.close()	#20230203
		self._popup.dismiss()



	def QuitRun (self):#日志后退出
#		print("\t\t***进入QuitRun***")
#		self.Diary()		
		#QCoreApplication.instance().quit
		sys.exit()



	def Diary (self):#日志
	#	print("\t\t***进入日志模块Diary***")
		IndexLogFile=os.path.join(os.getcwd(),"src",self.IndexLogFile)
		f1=open(IndexLogFile,mode='a+t',encoding='UTF-8')
		if f1:#摘引日志总文件
			f1.seek(0)
			data1=f1.read()
			list1=data1.split("\n")
			ld1=os.path.getsize(IndexLogFile)#日志文件大小
	#		print("\t文件『",IndexLogFile,"』总字数",ld1)
		Indexpath=os.path.join(os.getcwd(),self.IndexFile)
		f=open(Indexpath,mode='a+t',encoding='UTF-8')#0406
		if f:#本次摘引文件
			f.seek(0)
			data=f.read()
			f.close()
		listt=data.split("\n")
		ltt0=listt[0]#记录当前日志的时间戳
		RecP=False
		l1=len(list1)-1
		if(ld1>10):#检查日志是否记录过，字数大于10
			if(l1>2):#行数大于2
	#			print("\t日志共(",len(list1),")行，检测日志是否已经记录过[",ltt0,"]摘录")
#				print("\tlist1=",list1)
				for i in range(l1,0,-1):#倒序循环查找时间戳
#					print("\t\t(",i,") [",list1[i],"]",end="")
					if(list1[i].find(ltt0)>=0):#如果发现时间戳相同
	#					print("\t\t总(",len(list1),")行，倒查到第(",i,")行日志已经记录过摘录[",ltt0,"]，忽略以避免重复记录")
						RecP=True#标记已经记录过
						break
	#	else:
	#		print("\t日志共(",len(list1),")行，检测日志未记录过[",ltt0,"]摘录")
		if not RecP:#对没有记录过的日志
			lt=len(listt)#统计行数，以便加入数字括号格式文件
			f1=open(IndexLogFile,mode='w+t',encoding='UTF-8')
			if f1:
				f1.seek(0)#文件指针移到文件末(0,2) 0417改为文件头
				if(ld1<=10):
					f1.write("0 "+str(lt)+"\n")	
#					print("\n新建文件「",IndexLogFile,"」首行为\n0 "+str(l1+1)+"\n后面追加记录：\n")
					for i in range(lt-1):
#						print(listt1[i])
						f1.write(listt[i]+"\n")		
					f1.write("\n"+str(lt))	
#					print("\n"+str(ltt1+1))
				else:
					for i in range(l1):#0417改写日志格式，提高正确稳定性
						f1.write(list1[i]+"\n")	
					f1.write(list1[l1]+" "+str(lt)+"\n")	#格式行
					for i in range(lt-1):
#						print(listt[i])
						f1.write(listt[i]+"\n")		
					f1.write("\n"+str(lt))	
#					print("\n"+str(lt+1))
				f1.close()


	def handle (self):#计算所选行
#		i=self.OnOpNumber()#pyqt5中用列表行获取，在kv中采用编辑框
#		mystr=self.model.item(i).index().data()
#		print("获取字串",mystr)
		mystr=self.root.ids['Text_Edit'].text #__self__ #kv获取编辑框输入
		numberp=self.IsNumber(mystr)
#		if(numberp):	
#			print("所获取字串是数字")
#			self.FirstLine(mystr)
		if(not numberp):#else:
			fmt=self.floatfmt(mystr)
		#	print("所获取字串非数字，开始计算，小数位数为(",fmt,")位")#0605
#			mystrt=self.AltStr(mystr,fmt,1)#20230604
#			mystrl=mystrt.split()
#			print("\t字串解析成为[",mystrt,"]，试图转为表：",mystrl)
#			if(len(mystrl)>1):
#				mystr=mystrl[0]
#			else:
#				mystr=mystrt

			mystr=self.AltStrm(mystr,fmt,1)#.split()[0]#0605 self.strcacu(mystr)#0605 
#			print("\t计算结果为[",mystr,"]")
	#		value=float(mystr)
#	#		print("Alt实数运算结果：",value)
	#		if((abs(value)<1e5) and (abs(value) >1e-3)):
	#			mystr=str(round(value,fmt))#self.fmt))
	#			print("Alt实数自动判断输出小数位",fmt,"，数字输出为",mystr)

#			self.FirstLine(mystr)#kv改写如下
			self.root.ids['Text_Edit'].clear_widgets()
			self.root.ids['Text_Edit'].text = mystr#+"??"

	def IsNumber (self,localstr):#检测字串是否实数
		lens=len(localstr)
#		print("进入IsNumber模块,检测字串[",localstr,"]共",lens,"个字符，是否实数？")
		if(lens > 0):
			i1=0
			state=0
			while(i1<lens):
				if(i1==0):
#					print("\t\t",localstr[i1])
					if (localstr[i1].isdigit( ) or (localstr[i1] == '.') or #字串是数字？
						(localstr[i1] == '-') or (localstr[i1]=='+')):
						state+=0
					else:
						state+=1
#					print("\t0表示数字，state=",state)
				else:
#					print("\t\t",localstr[i1])
					if ((localstr[i1] == 'e')or(localstr[i1] == 'E')):#科学计数
						if(len(localstr)>i1+1):
							if(localstr[i1] == 'e'):
								substre=localstr.split('e')[1]
								if self.IsFloat(substre):
									state+=0
							elif(localstr[i1] == 'E'):
								substrE=localstr.split('E')[1]
								if(self.IsFloat(substrE)):
									state+=0
							else:
								state+=1
						else:
							state+=1
					elif (not (localstr[i1].isdigit() or (localstr[i1] == '.'))):
						state+=1
#					print("\t\t0表示数字，state=",state)
				i1+=1

			if state>0:
#				print("\t字串[",localstr,"]不是数字。")
				justnumber=False
			else: 
#				print("\t字串[",localstr,"]是数字。")
				justnumber=True
		else:
			justnumber=False
		return justnumber


	
	def IsFloat(self,localstr):#检测字串是否浮点实数
#		print("进入IsFloat",localstr)
		lens=len(localstr)
		i1=0
		state=0
		while(i1<lens):
			if(i1==0):
				if (localstr[i1].isdigit( ) or (localstr[i1] == '.') or #字串是数字？
					(localstr[i1] == '-') or (localstr[i1]=='+')):
					state+=0
#					print("\t\t",localstr[i1])
				else:
					state+=1
#					print("\tstate=",state)
			else:
				if ((localstr[i1] == '.') or localstr[i1].isdigit( )):
					state+=0
#					print("\t\t",localstr[i1])
				else:
					state+=1
#					print("\tstate=",state)
			i1+=1
		if state>0:
#			print("\t字串[",localstr,"]不是纯浮点数。")
			justnumber=False
		else: 
#			print("\t字串[",localstr,"]是纯浮点数。")
			justnumber=True
		return justnumber



	def floatfmt (self,lstr):#获取浮点小数位
	#	print("检测字串：",lstr,"的小数位数->")
		ll=len(lstr)
		i0=lstr.find('.')
		imax=0
		if(i0>=0):
	#		print("第",i0,"位为小数点.")
			i1=i0+1
			it=0
			for i2 in range(i1,ll):
				if(lstr[i2].isdigit()):
					it+=1
					if(it>imax):
						imax=it
				else:
					it=0
					i0=lstr.find('.',i1)
					if(i0>i2 and i2<ll-1):
						i1=i0+1
	#		print("字串：",lstr,"的小数位数为：",imax)
		return imax


	def AltStr (self,slecstr,digit_num,expbnow):#分层拆解括号串
#digit_num,8模块判断小数位数，>=0表强制输出小数位,-3表示不计算；expbnow表示计算1与否0,也表示当前表首项self.Expbnow位置
		self.root.ids['Text_Edit'].text += "3"
		
#		print("\n\n\t＝＝＝进入计算字符串分解方法AltStr：",slecstr)
#		str1=self.ui.lineEdit_2.text()
#		slecstr=self.model.item(0).index().data()#获0行字符#1015
		mystr=slecstr#测试计算字串 2str3*sin2.000 3str2*cos3.000
#		print("字串为：",mystr)
		strpara=" "
		str1=mystr
#		print("字串为：",str1,"分隔符为[",strpara,"]")
		#strlist=[]
		strlist=str1.split()#strpara
		ns = len(strlist)
		#i1 = len(strpara)
	#	print("一级分解后计算字符串成为表：",strlist,"\t共",ns,"项")
		#if (i1==0):
		#	strpara0=""
		itt=0
		pickp=False
		while(itt<ns):#各表项遍历
			mystr= strlist[itt]
			str1t = strlist[itt]#分解的字串项
	#		print("\n从0第(",itt,")项分解的字串项：",str1t)
			fmt=self.floatfmt(str1t)#v0.60
	#		print("\t字串小数位数：",fmt)
			bracketn = 0
			slen = len( str1t)
			nct =0 
			while(nct < slen):
				strn = str1t[nct]
				nct+=1
				if(strn == '('):
					bracketn = bracketn+1
	#		print("字符",str1t,"有",bracketn,"个括号")
			nct1=0
			k1=0
			passn=0
			while(k1<=bracketn):#v0.951while(k1<bracketn):#各层括号解析
				if(passn>=slen-1):
	#				print("\n\t循环入口，忽略串长",passn,">=净字符数：",slen)	
					break
	#			else:
	#				print("\n\t循环入口，忽略串长",passn,"<净字符数：",slen)						
				bracketnt = 0
				numn = 0
				bracketb = 0
				brackete = 0
				nct = 0
				sta = 1
				slen = len( str1t)
				while (nct < slen):#找出(需拆解的)最内层括号序号v0.963
					if(nct>nct1+passn):#
						strn = str1t[nct]
						if(strn == '(') :
							bracketnt = nct
						elif(strn==')') :
							bracketb = bracketnt
							brackete = nct
							break
					nct +=1
				sta=brackete-bracketb-1
			#	print("\t第",k1,"层括号开始于：",bracketb,"\t结束于",brackete,"\t净字符数：",sta,"忽略串长",passn)
				if(bracketn==0):#:k1#v0.951没有括号
					prestr =""
					midstr = mystr#strlist[itt]#str1t
					endstr =""
					oristr=""
				elif(k1==bracketn):
					prestr =""
					midstr = str1t
					endstr =""
					oristr=""
				else:

					prestr = str1t[0:bracketb]
					midstr = str1t[(bracketb+1):brackete]
					endstr = str1t[(brackete+1):]
					oristr=midstr
		#		print("\t第(",k1,")层括号分解后，前串[",prestr,"]\t中串[",midstr,"]\t后串[",endstr,"]操作格式行号(",expbnow,"]")
				if(expbnow>=0):#!=0):v0.952由之前的计算标志修改为全显页顶行
			#		print("\t非首页，判断为需变量代换，串长",len(midstr))
					transferp=False
					if (len(midstr) >0):#!= 0):
#						print("\t\talt中间字串：",midstr)
#						if(midstr.find('@')>=0):#midstr[0]=='@'):
						if(midstr[0]=='@'):
			#				print("\t\t首字为@，AltStr准备弹出框运行")#如果字串末为#时，表示取为关键词20230224v0.981
							midstr = self.PopList(midstr,expbnow)
							if(midstr!=""):#len(midstr)>0):#20230225
								transferp=True
			#					print("\t\t\tAltStr从弹出框获得输入[",midstr,"]字长",len(midstr),"输入有效")
							else:
								self.AutoMode=False
			#					print("\t\t\tAltStr从弹出框获得输入[",midstr,"]字长",len(midstr),"为零，故无效，自动摘录模式取消->",self.AutoMode)
						elif(midstr[0]=='!' or midstr[0]=='！'):#0327导入内部取值time
							if(midstr[1:]=="时间"):
								midstr=self.Ztime(1)
			#					print("\t\t首字!字符串，返回时间[",midstr,"]")
							elif(midstr[1:]=="与关键词"):
								midstr=self.KeyWordStr
			#					print("\t\t首字!字符串，返回'与'关键词[",midstr,"]")
							elif(midstr[1:]=="或关键词"):
								midstr=self.KeyWordStr2
			#					print("\t\t首字!字符串，返回'或'关键词[",midstr,"]")
							elif(midstr[1:]=="LastKey"):
								midstr=self.LastKey
			#					print("\t\t首字!字符串，返回LastKey[",midstr,"]")
						elif(not self.IsNumber(midstr)):#如果有非数字符，进行解析
			#				print("\t\t首字非@，进入非弹出框操作")

							nabeP=False
							lmid=len(midstr)
							if(midstr.find(':')>=0):
								if(midstr.find('~')>=0):
									nabeP=True
							if(midstr.find('?')>=0):
								nabeP=True
							if(midstr.find(',')>=0):
								nabeP=True
							if nabeP:
			#					print("\t\t\t",midstr,"首字非@，内含:?,字符串分支2,调用PickList求值,操作格式行号[",expbnow,"]")
								pklist=self.PickList(midstr,expbnow)
			#					print("\t\tPicklist返回表",pklist)
								lp=len(pklist)
								if(lp==1):
									midstr=pklist[0]
								elif(lp==2):
									midstr=pklist[0]
									if(len(pklist[1])>0):
										pickstr2=pklist[1]
										pickp=True
			#					print("\t\t\t选取首项返回结果[",midstr,"]，第二项附于总返回值末")
								transferp=True
							elif(midstr.find('#')>=0):#末尾#表示有小数进一取整
								if(self.IsNumber(midstr[:-1])):
									midstr=self.EngInt(midstr[:-1])
#								print("\t\t\t\t无@有＃字符串分支4,小数进一取整成",midstr)
							elif(midstr.find('、')>=0 and midstr.find('；')>=0):#当发现关键词或条件分隔符'、',与条件'；'时，搜索并弹出框
			#					print("\t\t\t发现特殊符号[、][；]，准备进入弹框搜索->")
								midstr=self.HuntPop(midstr)#20230224v0.981***
							else:#就在索引文件中找变量的赋值
								print("\t\t\t\t无@无:?;＃字符串分支5")
								Indexpath=os.path.join(os.getcwd(),self.IndexFile)
								print("摘引文件字串为[",Indexpath,"]")
								if(os.path.exists(Indexpath)):
									print("发现Indexpath：",Indexpath)
									self.root.ids['handle'].text += "1"

								fh1=open(Indexpath,mode='r',encoding='UTF-8')
								if fh1:
									data=fh1.read()
									filelist=data.split("\n")
									fh1.close()
			#					print("midstr[",midstr,"]准备搜索摘引文件变量")
								if(data.find(midstr)>=0):
			#						print("\t\tAltStr搜寻索引文件:",Indexpath,"扫描发现待确认赋值变量字串[",midstr,"]")
									parap=False
									lf=len(filelist)
									for il in range(lf-1,0,-1):#
										linedata=filelist[il]
										lls=len(linedata.split())
										if(lls>3):
							#				print("\t扫描",il,"行[",linedata,"]")
							#				if(linedata.split()[3].find(midstr)>=0):
											loclist=self.psplit(linedata,'"','"')
											llsp=len(loclist)
							#				print("\t\t双引号分隔成的列表项数:",llsp)
											if(llsp>=3):
												if(loclist[2].find(midstr)>=0):
													if(loclist[1][1:-1].strip()):
														parap=True
														strt=loclist[1][1:-1]#midstr
														if(strt[-1]=='⌇'):
															strt=strt[:-1]
				#										print("\t\t搜索摘引文件",il,"行",loclist[2],"中发现字串[",midstr,"]->变量值确认为[",strt,"]")
														break
			#								else:
			#									print("\t\t双引号拆分列表项数小于3")
									if parap:
										midstr=strt
									if(digit_num!=-3):
		#								print("\t\t\tAltstr中间1待计算字串[",midstr,"]")
										if(not self.IsNumber(midstr)):
											midstr=self.strcacu(midstr,digit_num)
										#midstr=self.strcacu(midstr,digit_num)
									if(midstr==oristr and (not self.IsNumber(midstr))):
										midstr='('+midstr+')'
										passn+=brackete#括号查找点后推到忽略括号后
		#								print("\t\t\t变量代换未确认,返回原表字串[",midstr,"]")
								else:
									if(digit_num!=-3):
		#								print("\t\t\tAltstr中间2待计算字串[",midstr,"]")
										if(not self.IsNumber(midstr)):
											midstr=self.strcacu(midstr,digit_num)
										#midstr=self.strcacu(midstr,digit_num)
									if(midstr==oristr and (not self.IsNumber(midstr))):
										midstr='('+midstr+')'
										passn+=brackete#括号查找点后推到忽略括号后
		#								print("\t\t变量代换搜寻摘引文件:",Indexpath,"未找到变量代换,返回原表字串[",midstr,"]")
#						print("\t首字符判断后，midstr＝",midstr)
						mystr=midstr
						str1t=prestr+mystr
						str1t=str1t+endstr
						mystr=str1t
						midstr=str1t#v0.951
		#				print("\t第(",k1,")次括号运算后，成为串[",str1t,"]")
				else:
					print("\t\t判断为不需变量代换")

				if(not transferp):
					k1+=1	
				else:
					#if(k1>bracketn):
					#str1t=midstr
					ncte =0 #v0.967
					slen=len(str1t)
					bracketn=0
					#passn=0
					while(ncte < slen):
						strn = str1t[ncte]
						ncte+=1
						if(strn == '('):
							bracketn = bracketn+1
					if(bracketn>0):
						k1=0
		#			print("循环末重新统计字符串[",str1t,"]内有(",bracketn,")个括号")
					if(bracketn<=0):break #20230331

#			print("运算前，字串为：",mystr)#v0.85
			if(digit_num!=-3):#v0.952调整digit_num==-3为不计算
#				print("Altstr中间4待计算字串[",mystr,"]")
				if(not self.IsNumber(mystr)):
					mystr=self.strcacu(mystr,digit_num)
#			print("运算后，成为串：",mystr)
			#v0.60小数位输出
			if(self.IsNumber(mystr)):#20230218
				value=float(mystr)
#				print("Alt实数运算结果：",value)
				if(digit_num==8):#<0):v0.97确定8为自动判断，-3不计算
					if((abs(value)<1e5) and (abs(value) >1e-3)):
						mystr=str(round(value,fmt))#self.fmt))
#						print("Alt实数自动判断输出小数位",fmt,"，数字输出为",mystr)
				elif(digit_num>=0):					
					if((abs(value)<1e5) and (abs(value) >1e-3)):
						if(digit_num==0):
							mystr=str(round(value))
						else:
							mystr=str(round(value,digit_num))
#						print("Altstr强制输出小数位",digit_num,"，数字输出为",mystr)
#				else:
#					print("Altstr第2项参数",digit_num,"无格式变动，输出为",mystr)
			strlist[itt]=mystr
	#		print("\n\t共(",ns,")项之第(",itt,")表项运算后，成为串：",strlist[itt])
			if(itt==0):
				str1=strlist[itt]
			else:
				str1=str1+" "+strlist[itt]
			itt+=1

			if(pickp):
				str1=str1+' '+pickstr2
	#		print("\n\t＝＝＝Altstr第",k1,"层括号运算后，成为串：\n\t\t[",str1,"]\n")
		return str1#0607退格一档输出多项

	def AltStrm (self,slecstr,digit_num,expbnow):#分层拆解括号串
#digit_num,8模块判断小数位数，>=0表强制输出小数位,-3表示不计算；expbnow表示计算1与否0,也表示当前表首项self.Expbnow位置
		
	#	print("\n\n\t＝＝＝进入计算字符串分解方法AltStr：",slecstr)
#		str1=self.ui.lineEdit_2.text()
#		slecstr=self.model.item(0).index().data()#获0行字符#1015
		mystr=slecstr#测试计算字串 2str3*sin2.000 3str2*cos3.000
#		print("字串为：",mystr)
		strpara=" "
		str1=mystr
#		print("字串为：",str1,"分隔符为[",strpara,"]")
		#strlist=[]
		strlist=str1.split()#strpara
		ns = len(strlist)
		#i1 = len(strpara)
#		print("一级分解后计算字符串成为表：",strlist,"\t共",ns,"项")
		#if (i1==0):
		#	strpara0=""
		itt=0
		pickp=False
		while(itt<ns):#各表项遍历
			mystr= strlist[itt]
			str1t = strlist[itt]#分解的字串项
	#		print("\n分解的字串项：",str1t)
			fmt=self.floatfmt(str1t)#v0.60
	#		print("\t字串小数位数：",fmt)
			bracketn = 0
			slen = len( str1t)
			nct =0 
			while(nct < slen):
				strn = str1t[nct]
				nct+=1
				if(strn == '('):
					bracketn = bracketn+1
	#		print("字符",str1t,"有",bracketn,"个括号")
			nct1=0
			k1=0
			passn=0
			while(k1<=bracketn):#v0.951while(k1<bracketn):#各层括号解析
				if(passn>=slen-1):
	#				print("\n\t循环入口，忽略串长",passn,">=净字符数：",slen)	
					break
	#			else:
	#				print("\n\t循环入口，忽略串长",passn,"<净字符数：",slen)						
				bracketnt = 0
				numn = 0
				bracketb = 0
				brackete = 0
				nct = 0
				sta = 1
				slen = len( str1t)
				while (nct < slen):#找出(需拆解的)最内层括号序号v0.963
					if(nct>nct1+passn):#
						strn = str1t[nct]
						if(strn == '(') :
							bracketnt = nct
						elif(strn==')') :
							bracketb = bracketnt
							brackete = nct
							break
					nct +=1
				sta=brackete-bracketb-1
			#	print("\t第",k1,"层括号开始于：",bracketb,"\t结束于",brackete,"\t净字符数：",sta,"忽略串长",passn)
				if(bracketn==0):#:k1#v0.951没有括号
					prestr =""
					midstr = mystr#strlist[itt]#str1t
					endstr =""
					oristr=""
				elif(k1==bracketn):
					prestr =""
					midstr = str1t
					endstr =""
					oristr=""
				else:

					prestr = str1t[0:bracketb]
					midstr = str1t[(bracketb+1):brackete]
					endstr = str1t[(brackete+1):]
					oristr=midstr
			#	print("\t第(",k1,")层括号分解后，前串[",prestr,"]\t中串[",midstr,"]\t后串[",endstr,"]操作格式行号(",expbnow,"]")
				if(expbnow>=0):#!=0):v0.952由之前的计算标志修改为全显页顶行
			#		print("\t非首页，判断为需变量代换，串长",len(midstr))
					transferp=False
					if (len(midstr) >0):#!= 0):
#						print("\t\talt中间字串：",midstr)
						if(digit_num!=-3):
		#					print("\t\t\tAltstr中间2待计算字串[",midstr,"]")
							if(not self.IsNumber(midstr)):
								midstr=self.strcacu(midstr,digit_num)
							#midstr=self.strcacu(midstr,digit_num)
						if(midstr==oristr and (not self.IsNumber(midstr))):
							midstr='('+midstr+')'
							passn+=brackete#括号查找点后推到忽略括号后
#							print("\t\t变量代换搜寻摘引文件:",Indexpath,"未找到变量代换,返回原表字串[",midstr,"]")
#						print("\t首字符判断后，midstr＝",midstr)
						mystr=midstr
						str1t=prestr+mystr
						str1t=str1t+endstr
						mystr=str1t
						midstr=str1t#v0.951
		#				print("\t第(",k1,")次括号运算后，成为串[",str1t,"]")
				else:
					print("\t\t判断为不需变量代换")

				if(not transferp):
					k1+=1	
				else:
					#if(k1>bracketn):
					#str1t=midstr
					ncte =0 #v0.967
					slen=len(str1t)
					bracketn=0
					#passn=0
					while(ncte < slen):
						strn = str1t[ncte]
						ncte+=1
						if(strn == '('):
							bracketn = bracketn+1
					if(bracketn>0):
						k1=0
		#			print("循环末重新统计字符串[",str1t,"]内有(",bracketn,")个括号")
					if(bracketn<=0):break #20230331

#			print("运算前，字串为：",mystr)#v0.85
			if(digit_num!=-3):#v0.952调整digit_num==-3为不计算
#				print("Altstr中间4待计算字串[",mystr,"]")
				if(not self.IsNumber(mystr)):
					mystr=self.strcacu(mystr,digit_num)
	#		print("运算后，成为串：",mystr)
			#v0.60小数位输出
			if(self.IsNumber(mystr)):#20230218
				value=float(mystr)
	#			print("Alt实数运算结果：",value)
				if(digit_num==8):#<0):v0.97确定8为自动判断，-3不计算
					if((abs(value)<1e5) and (abs(value) >1e-3)):
						mystr=str(round(value,fmt))#self.fmt))
#						print("Alt实数自动判断输出小数位",fmt,"，数字输出为",mystr)
				elif(digit_num>=0):					
					if((abs(value)<1e5) and (abs(value) >1e-3)):
						if(digit_num==0):
							mystr=str(round(value))
						else:
							mystr=str(round(value,digit_num))
	#					print("Altstr强制输出小数位",digit_num,"，数字输出为",mystr)
#				else:
#					print("Altstr第2项参数",digit_num,"无格式变动，输出为",mystr)
			strlist[itt]=mystr
#			print("\n\t第",itt,"表项运算后，成为串：",strlist[itt])
			if(itt==0):
				str1=strlist[itt]
			else:
				str1=str1+" "+strlist[itt]
			itt+=1

			if(pickp):
				str1=str1+' '+pickstr2
	#		print("\n\t＝＝＝Altstr第",k1,"层括号运算后，成为串：\n\t\t[",str1,"]\n")
		return str1#0607退格一档输出多项



	def strcacu (self,mystr,fmt):#算式串计算转化0608
		caculist1=["sin","cos","tg","ctg","arcsin","arccos","arctg","sinh","cosh","tgh","abs","rand"]
		caculist2=["^", "ln", "lg"]
		caculist3=["*","/"]
		caculist4=["+", "-"]
		listn = 12
		passt = 0
#		self.mystr=self.ui.lineEdit_2.text()
		found1 = len(mystr)
		rank =listn
		inow=0
		i1=0
		value=""
	#	print("\t\t\t进入字符串计算strcacu，字符串为：",mystr)

		while i1<listn:
			foundt = mystr.find(caculist1[i1],inow)#1014self.
			if(foundt>=0): 
				print("计算字符串[ ",mystr," ]中发现一级优先计算符(",caculist1[i1],")位于",foundt)#self.
				if(foundt <= found1):
					rank = i1
					found1 =foundt
				passt = 1
			i1 +=1
		print("\n位置1发现")#,self.mystr,"第[",rank,"]运算串",caculist1[rank])
		while(passt ==1):
			numbers = 0
			i5=0
			print("\t一级前strcacu->ArrangStr中一级运算符:",caculist1[rank],",found1=",found1)
			if(found1>=0):
				loclist=self.ArrangStr(mystr,caculist1[rank])#v0.956
				numt1id=loclist[0]
				numt1=loclist[1]
			value=""
			if(numt1id[3]==1):#当第四栈数字标记为“有”时20230608
				cacustrt3 = numt1[3]#取第四栈数字
				if(self.IsNumber(cacustrt3)):
					para3= float (cacustrt3)
				print("\tstrcacu函数输入值：",cacustrt3)
				if(numt1id[1]==1):#当第二栈数字标记为“有”时20230608
					cacustrt = numt1[1]#取第二栈数字
					para1= float (cacustrt)
					print("\tstrcacu函数输入值：",cacustrt)
					if(numt1[2]=="sin"):
						
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.sin (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
#						print("\tself.IsNumber(cacustrt)值：",self.IsNumber(cacustrt))
						
#						else:print("\tcacustrt.isalnum()值：",cacustrt.isalnum())
					if(numt1[2]=="cos" ):
						
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.cos (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="tg"):
					
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.tan (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="ctg"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							tv=math.tan (para3)
							if(tv>1e-5):
								value = para1 / tv
								numt1[1]=""
								numt1id[1]=0
								numt1[3]=""
								numt1id[3]=0
								numbers = 1
							else:
								print("\t\t请检查ctg参数")
					if(numt1[2]=="arcsin"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.asin (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="arccos"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.acos (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="arctan"):
					
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.atan (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="asinh"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.asinh (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="acosh"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.acosh (para3)
							numbers = 1
					if(numt1[2]=="atanh"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.atanh (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="abs"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							value = para1 * math.fabs (para3)
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					if(numt1[2]=="rand"):
						
#						print("\tstrcacu函数输入值：",cacustrt3)
						if(self.IsNumber(cacustrt) and self.IsNumber(cacustrt3)):
							para3= math.fabs(float (cacustrt3))
							value = para1 * random.randint(1,int(para3)) #0608 radom.randint()
							numt1[1]=""
							numt1id[1]=0
							numt1[3]=""
							numt1id[3]=0
							numbers = 1
					else:#没有数字时略过
						passt=0
			else:#当第四栈数字标记为“无”时20230608
				if(numt1id[1]==1):#当第二栈数字标记为“有”时20230608
					cacustrt = numt1[1]#取第二栈数字
					if(self.IsNumber(cacustrt)):
						para1= float (cacustrt)
#					print("\tstrcacu函数输入值：",cacustrt)
					if(numt1[2]=="sin"):
						
						if(self.IsNumber(cacustrt)):
							value = math.sin (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
#						print("\tself.IsNumber(cacustrt)值：",self.IsNumber(cacustrt))
						
#						else:print("\tcacustrt.isalnum()值：",cacustrt.isalnum())
					if(numt1[2]=="cos" ):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.cos (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="tg"):
					
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.tan (para1)
							numbers = 1
					if(numt1[2]=="ctg"):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = 1.0/math.tan (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="arcsin"):
						
						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.asin (para1)
							numbers = 1
					if(numt1[2]=="arccos"):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.acos (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="arctan"):
					
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.atan (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="asinh"):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.asinh (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="acosh"):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.acosh (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="atanh"):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.atanh (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="abs"):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							value = math.fabs (para1)
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					if(numt1[2]=="rand"):
						
#						print("\tstrcacu函数输入值：",cacustrt)
						if(self.IsNumber(cacustrt)):
							para1= math.fabs(float (cacustrt))
							value = random.randint(1,int(para1)) #0608 radom.randint()
							numt1[1]=""
							numt1id[1]=0
							numbers = 1
					else:#没有数字时略过
						passt=0

			if(value != ""):#滚动输出
				if(numt1id[0]==1):
					if(not self.Formular(numt1[0])):
						strv=str(round(value,fmt))
					else:
						strv=str(value)
					mystr=numt1[0]+strv#0606 str(value)
					numt1id[0]=0
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]
						numt1id[4]=0
				else:
					mystr=str(value)
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]
						numt1id[4]=0
				print("一级运算",cacustrt,")","\t计算结果值：",value,"mystr=",mystr)#self.
			else:#1014
				inow+=found1+1

#		print("\n位置2",mystr)
		listn = 3
		passt = 0
		found1 = len(mystr)
		rank =listn
		inow=0
		i1=0
		while (i1<listn):
			foundt = mystr.find(caculist2[i1],inow)
#			print("\t遍历一级计算串[",i1,"]=",caculist2[i1],"foundt=",foundt)
			if(foundt>=0): 
#				print("计算字符串[ ",mystr," ]中发现二级优先计算符(",caculist2[i1],")")#self.
				if(foundt <= found1):
					rank = i1
					found1 =foundt
				passt = 1
			i1+=1
		while(passt ==1):
			numbers = 0
			i3=rank
#			print("\t二级前strcacu->ArrangStr中运算符:",caculist2[rank])
			loclist=self.ArrangStr(mystr,caculist2[rank])#1014self.
			numt1id=loclist[0]
			numt1=loclist[1]
			value=""
			numbers=0
			if(numt1id[1]==1):
				if( numt1[2]=="^"):
					if(numt1id[1]==1):
						cacustrt1 = numt1[1]
						numt1id[1]=0
						numbers+=1
#						print("\tstrcacu函数输入值一：",cacustrt1)
					if(numt1id[3]==1):					
						cacustrt2 = numt1[3]
						numt1id[3]=0
						numbers+=1
#						print("\tstrcacu函数输入值二：",cacustrt2)
						para2= float (cacustrt2)
						numt1id[3]=0
					if((cacustrt1[0] == 'e') or (cacustrt1[0] == 'E')):
						numt1id[1]=0
						value = math.exp (para2)
					elif (numbers>=2) :
						para1= float (cacustrt1)
						#numt1id[1]=0
						value = math.pow (para1,para2)
#						print(cacustrt1,"^",cacustrt2,"=",value)
				if( numt1[2]=="ln"):
					if(numt1id[3]==1):
						cacustrt3 = numt1[3]
						para3= float (cacustrt3)
						if(numt1id[1]==1):
							if(self.IsNumber(numt1[1]) and self.IsNumber(numt1[3])):
								cacustrt = numt1[1]
								numt1id[1]=0
								numt1id[3]=0
#								print("\tstrcacu函数ln输入值：",cacustrt)
								para1= float (cacustrt)
								#numbers =1
								value = para1 * math.log (para3)
								#print("\tln",cacustrt,"=",value)
					else:
						if(numt1id[1]==1):
							if(self.IsNumber(numt1[1])):
								cacustrt = numt1[1]
#								print("\tstrcacu函数ln输入值：",cacustrt)
								para1= float (cacustrt)
								#numbers =1
								value = math.log (para1)
								numt1id[1]=0

				if( numt1[2]=="lg"):
					if(numt1id[3]==1):
						cacustrt3 = numt1[3]
						para3= float (cacustrt3)
						if(numt1id[1]==1):
							
							cacustrt = numt1[1]
#							print("\tstrcacu函数ln输入值：",cacustrt)
							para1= float (cacustrt)
							#numbers =1
							value = para1 * math.log10 (para3)
							numt1id[1]=0
							#print("\tlg",cacustrt,"=",value)
#						print("\n\t***mystr值更新为",mystr)
					else:
						if(numt1id[1]==1):
							
							cacustrt = numt1[1]
#							print("\tstrcacu函数ln输入值：",cacustrt)
							para1= float (cacustrt)
							#numbers =1
							value = math.log10 (para1)
							numt1id[1]=0
							#print("\tlg",cacustrt,"=",value)
		#				mystr=str(value)
#						print("\n\t***mystr值更新为",mystr)

			if(value != ""):#滚动输出
				if(numt1id[0]==1):
					if(not self.Formular(numt1[0])):
						strv=str(round(value,fmt))
					else:
						strv=str(value)
					mystr=numt1[0]+strv#0606 str(value)
					numt1id[0]=0
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]
						numt1id[4]=0
				else:
					mystr=str(value)
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]
						numt1id[4]=0
				print("二级运算计算结果值：",value,"\tmystr=",mystr)#self.
				#self.ui.lineEdit_3.setText(self.mystr)
			else:
				inow+=found1+1

	
			passt = 0
			found1 = len(mystr)
			rank =listn
			i2=0
			while(i2<listn):
				foundt = mystr.find(caculist2[i2],inow)#1014#self.
				#foundt = found(caculist2[i1],str)
				if(foundt>=0): 
					if(foundt <= found1):
						rank = i2
						found1 =foundt
					passt = 1
				i2+=1

#		print("\n位置3",mystr)#self.
		listn = 2
		passt = 0
		found1 = len(mystr)#self.
		rank =listn
		inow=0
		i1=0
		while(i1<listn):
			foundt = mystr.find(caculist3[i1],inow)
			if(foundt>=0): 
#				print("计算字符串[ ",mystr," ]中发现三级优先计算符(",caculist3[i1],")")#self.
				if(foundt <= found1):
					rank = i1
					found1 =foundt
				passt = 1
			i1+=1
		while(passt ==1):
			numbers = 0
			i3=rank
#			i5=0
#			print("\t三级前strcacu->ArrangStr中运算符:",caculist3[rank])
			loclist=self.ArrangStr(mystr,caculist3[rank])
			numt1id=loclist[0]
			numt1=loclist[1]
			value=""
			if(numt1id[3]==1):
				if( numt1[2]=="*"):
					if(numt1id[1]==1):
						
						cacustrt1 = numt1[1]
#						print("\tstrcacu函数输入值*：",cacustrt1)
						if(cacustrt1.isdigit() or (cacustrt1[0]=='-' and cacustrt1[1:].isdigit())):
							para1= int (cacustrt1)
						else:
							para1= float (cacustrt1)
						#para1= float (cacustrt1)
						numbers +=1
						numt1id[1]=0
					if(numt1id[3]==1):
						
						cacustrt2 = numt1[3]
#						print("\tstrcacu函数输入值：%s\n",cacustrt2)
						if(cacustrt2.isdigit() or (cacustrt2[0]=='-' and cacustrt2[1:].isdigit())):
							para2= int (cacustrt2)
						else:
							para2= float (cacustrt2)
						#para2= float (cacustrt2)
						numbers +=1
						numt1id[3]=0
					if(numbers>1):
						value = para1 * para2
				if( numt1[2]=="/"):
					if(numt1id[1]==1):
						
						cacustrt1 = numt1[1]
#						print("\tstrcacu函数输入值/：%s\n",cacustrt1)
						if(self.floatfmt(cacustrt1)==0):
							para1= int (cacustrt1)
						else:
							para1= float (cacustrt1)
						#para1= float (cacustrt1)
						numbers +=1
						numt1id[1]=0
					if(numt1id[3]==1):
						
						cacustrt2 = numt1[3]
#						print("\tstrcacu函数/输入值：%s\n",cacustrt2)
						if(self.floatfmt(cacustrt2)==0):
							para2= int (cacustrt2)
						else:
							para2= float (cacustrt2)
						#para2= float (cacustrt2)
						numbers +=1
						numt1id[3]=0
					if(numbers>1):
						if(math.fabs(para2)<1e-10):
							print("除数不能为零！\n")
							QMessageBox.information(self,"Information","除数不能为零！请予以修正",
														QMessageBox.Ok,QMessageBox.Ok)# | QMessageBox.Cancel
						else :
							value = para1 / para2
	
			if(value != ""):#滚动输出
				if(numt1id[0]==1):
					if(not self.Formular(numt1[0])):
						strv=str(round(value,fmt))
					else:
						strv=str(value)
					mystr=numt1[0]+strv#0606 str(value)
					numt1id[0]=0
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]
						numt1id[4]=0
				else:
					mystr=str(value)
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]
						numt1id[4]=0
				print("三级运算结果值：",value,"mystr=",mystr)
			else:
				inow+=found1+1
					
			passt = 0
			found1 = len(mystr)
			rank =listn
			i1=0
			while(i1<listn):
				foundt = mystr.find(caculist3[i1],inow)
				#foundt = found(caculist3[i1],str)
				if(foundt>=0): 
					if(foundt <= found1):
						rank = i1
						found1 =foundt
					passt = 1
				i1+=1
#		print("\n位置4",mystr)#四级运算开始，＋，－
		listn = 2
		passt = 0
		found1 = len(mystr)
		rank =listn
		inow=0
		i1=0
		while(i1<listn):
			foundt = mystr.find(caculist4[i1],inow)
			if(foundt>=0): 
#				print("计算字符串[ ",mystr," ]中发现四级优先计算符(",caculist4[i1],")")#self.
				if(foundt <= found1):
					rank = i1
					found1 =foundt
				passt = 1
			i1+=1
		while(passt ==1):
			numbers = 0
			i3=rank
			i5=0
#			print("\t四级前strcacu->ArrangStr中运算符:",caculist4[rank])
			loclist=self.ArrangStr(mystr,caculist4[rank])
			if(len(loclist)>0):
				numt1id=loclist[0]
				numt1=loclist[1]
			else:
				numt1=[0,0,0,0,0]

			value=""
			if(numt1id[3]==1):

				if( numt1[2]=="+" ):
					if(numt1id[1]==1):
						cacustrt1 = numt1[1]
						if(cacustrt1.isdigit() or (cacustrt1[0]=='-' and cacustrt1[1:].isdigit())):
							para1= int (cacustrt1)
						#	print("整数",para1)
						else:
							para1= float (cacustrt1)
						#	print("实数",para1)
						numbers +=1
						numt1id[1]=0
						#print("\tstrcacu函数输入值1：",cacustrt1)
					if(numt1id[3]==1):
						cacustrt2 = numt1[3]
						if(cacustrt2.isdigit() or (cacustrt2[0]=='-' and cacustrt2[1:].isdigit())):
							para2= int (cacustrt2)
						#	print("整数",para2)
						else:
							para2= float (cacustrt2)
						#	print("实数",para2)
						numbers +=1
						numt1id[3]=0
						#print("\tstrcacu函数输入值2：",cacustrt2)
					else :
						passt=1
						break
					if(numbers>1):
						value = para1 + para2
						numbers = 2
				if( numt1[2]=="-"):
					if(numt1id[1]==1):
						cacustrt1 = numt1[1]#v0.73
						if(cacustrt1.isdigit() or (cacustrt1[0]=='-' and cacustrt1[1:].isdigit())):
							para1= int (cacustrt1)
							#print("整数",para1)
						else:
							para1= float (cacustrt1)
						numbers +=1
						numt1id[1]=0
					if(numt1id[3]==1):
						cacustrt2 = numt1[3]
						if(cacustrt2.isdigit() or (cacustrt2[0]=='-' and cacustrt2[1:].isdigit())):
							para2= int (cacustrt2)
							#print("整数",para2)
						else:
							para2= float (cacustrt2)
						numbers +=1
						numt1id[3]=0
					else :
						passt=1
						break
					if(numbers>1):
						value = para1 - para2
						numbers = 2
	
					passt = 0
					found1 = len(mystr)
					rank =listn
					i1=0
					while(i1<listn):
						foundt = mystr.find(caculist4[i1],inow)
						if(foundt>=0): 
							if(foundt <= found1):
								rank = i1
								found1 =foundt
							passt = 1
						i1+=1
				else:
					passt=0


			if(value != ""):#滚动输出
				if(numt1id[0]==1):
					if(not self.Formular(numt1[0])):
						strv=str(round(value,fmt))
					else:
						strv=str(value)
					mystr=numt1[0]+strv#0606 str(value)
					numt1id[0]=0
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]
						numt1id[4]=0
				else:
					mystr=str(value)
					if(numt1id[4]==1):
						mystr=mystr+numt1[4]#self.#self.
						numt1id[4]=0
				print("四级运算计算结果值：",value,"mystr=",mystr)
			else:
				inow+=found1+1
			#print("\n位置5",mystr)
			listn = 2
			passt = 0
			found1 = len(mystr)
			rank =listn
			i1=0
			while(i1<listn):
				foundt = mystr.find(caculist4[i1],inow)
				if(foundt>=0): 
					if(foundt <= found1):
						rank = i1
						found1 =foundt
						passt = 1
#					print("计算字符串[ ",mystr," ]中发现四级优先计算符(",caculist4[i1],")","foundt=",foundt,",found1=",found1,",passt=",passt)
				i1+=1
		print("\t\t\tstrcacu返回值：",mystr)
		return mystr


	def Formular (self,string):
		caculist=["sin","cos","tg","ctg","arcsin","arccos","arctg","sinh","cosh","tgh","abs","rand","^", "ln", "lg","*","/","+", "-"]
		ls=len(string)
		lcl=len(caculist)
		Np=False
		Cp=False
		Fp=False
		for i in range(ls):
			if (string[i].isdigit()):
				Np=True
				break
		for i in range(lcl):
			lc=len(caculist[i])
			if(string[-lc:]==caculist[i]):
				Cp=True
		if(Np and Cp):
			Fp=True
			return Fp


	def ArrangStr (self,lstr,symb):#字串数、符分拆至五位列表
		#lstr为字串，symb为运算符,五位列表：符、数、符、数、符
		state = 0
		statet = 0
		n5=[]
		i1=0
	#	print("\n进入ArrangStr,字符串为：[ ",lstr," ]运算符为：[",symb,"]\n")#(21.6^2+10^2)^0.5
		bracketn = 0
		slen = len (symb)
		xlen = len (lstr)
		ncs = 0
		nct = 0
		nct1 = 0
		pd0 = 0
		pd1 =0 
		founds=0
		pd3 = 0 
		strt = ""#'\0'
		numtt=numt=""
		numt1=["","","","",""]#self.
		numt1id=[0,0,0,0,0]#self.
		founds=lstr.find(symb)
		numberp=self.IsNumber(lstr)
	#	print("\n字串中发现运行符的位置为 ",founds,"是否数字:",numberp)
		loclist=[]
		if(founds>=0 and (not numberp)):
			while(nct < xlen):
				strnl = lstr[nct]#字串遍历 10+30^2*sinln4
	#			print("\n循环中,运算符为：[ ",symb," ]字符串为：[",lstr,"]\n")#30+50+70
	#			print("\n总共",xlen,"个字符，操作第",nct,"个字符，同类第",nct1,"个字符，当前字符[",strnl,"]")
	#			print("\n五位栈表当前：",numt1,"\n五位栈标记表当前：",numt1id,"中转串numtt[",numtt,"]\n")
				#字串是数字？#正负号#科学计数
				if (strnl.isdigit( ) or (strnl == '.') or (strnl == 'e')  or (strnl == 'E') or 
						(((strnl == '-')or(strnl=='+')) and (nct==0)) or 
						(((strnl == '-')or(strnl=='+'))	and ((lstr[nct-1] == 'e')or(lstr[nct-1] == 'E')))
					):
					state = 1
				else: state=0
#				print("状态参数：statet=",statet,"\tstate=",state)
				if(statet == state):#数与非数状态不变
					#print("\n\t数与非数状态不变")
					#print("\tnumt：",numt,"\tnumtt=",numtt,"\tnct1=",nct1)
					if(nct == (xlen-1)):#末字符时
						numt=numt+strnl#字串追加
						numtt=numt#记录字串
						if(state==1):#是数字
							if(numt1id[1]==0):
								numt1[1]=numtt#写入“数1串”栈[前串，数1串,运算串,数2串，后串]
								numt1id[1]=1#标记有“数1串”
								#print("\n\t分支1-1-1列表numt1：",numt1)
								#print("\n\t分支1-1-1列表numt1id：",numt1id)
							else:
								numt1[3]=numtt#已有“数1串”时写入“数2串”栈
								numt1id[3]=1#标记有“数2串”
								#print("\n\t分支1-1-2列表numt1：",numt1)
								#print("\n\t分支1-1-2列表numt1id：",numt1id)
						else:#不是数字
							if(numt1id[4]==0):
								numt1[4]=numtt#写入“后串”
								numt1id[4]=1#标记有“后串”
								#print("\n\t分支1-1-3列表numt1：",numt1)
								#print("\n\t分支1-1-3列表numt1id：",numt1id)
	
						break

					elif(nct==founds):#非末字#运算符处10+30^2*sinln4 1+2^3					
						numtt=numt #记录之前串符
						numt=strnl
						if(numt1id[0]==0):#"前串"栈空时，压栈
							numtp=lstr[0:nct]
							numt1[0]=numtp#列表第1格记录"前串"
							numt1id[0]=1#标记有"前串"
							numt1[2]=symb#列表第3格记录"运算串"
							numt1id[2]=1#标记有"运算串"
							nct+=slen-1
							state=0
							nct1=0
							numt=numtt=""
							#print("\n\t分支1-2高级运算符前串:",numtp)

					elif (strnl=="-"):#1014非末字为-号
						if(lstr[nct-1]!='e' and lstr[nct-1]!='E'):#v0.60
							if(nct<xlen-1):
								if(lstr[nct+1].isdigit( )):
									numtt=numt #记录之前串符
									numt=strnl
									#print("\t分支1-3数与非数状态未改变，但为‘-’号")
									#print("\tnumt：",numt,"\tnumtt=",numtt,"\tnct1=",nct1)
									nct1=0
									state=1
						else:#v0.60
							numt=numt+strnl					

					else:#非末字非运算符处
						numt=numt+strnl					
					nct1+=1
				else :#数与非数状态改变	
					numtt=numt #记录之前串符
					numt=strnl
		#			print("\t分支２数与非数状态改变")
		#			print("\tnumt：",numt,"\tnumtt=",numtt,"\tnct1=",nct1)
					nct1=0
					if(state==0):#分割串非数字时+
#						print("\t分支2-1为数字转非数字状态")
						if(nct == 0):#首字时
							numt=strnl
							#print("\n\t分支2-1-1首字串numt：",numt,"\tnct1=",nct1)
							nct1+=1#设置变化位置
	
						else:
							#numtt=numt #记录之前数符v0.6
							#numt=strnl#v0.6
							if (nct == (xlen-1)):#末字时
								#print("\n\t分支2-1-3末字串numt：",numt,"\t串长nct1=",nct1,"\tnumtt=",numtt)
								if(numt1id[1]==0):#"数1"栈空时，压栈
									numt1[1]=numtt#列表第2格记录运算串
									numt1id[1]=1#标记有"数1"
								elif (numt1id[3]==0):#"数2"栈空时，压栈
									numt1[3]=numtt#列表第4格记录运算串
									numt1id[3]=1#标记有"数2"

								if (numt1id[4]==0):
									numt=numt+strnl
									numt1[4]=numt#字串追加压入[后串栈]
									numt1id[4]=1#标记有后串
	
							elif(nct==founds) :#中字达到高级运算符时压栈数据
								#print("\n\t分支2-1-2中字串numt：",numt,"\tnumtt=",numtt)
								#print("\n\t\t分支2-1-2-1“数1串”空,压栈",numtt)
								numt1[1]=numtt#压栈列表第2格
								numt1id[1]=1#标记有“数1串”
								numt1[2]=symb#压栈列表第3格
								numt1id[2]=1#标记有“运算串”
								nct1=len(numtt) #临时借用nct1变量							
								if(nct1<nct+1):
									numt1[0]=lstr[0:founds-nct1]#压栈列表第1格
									numt1id[0]=1#标记有“前串”
								nct+=slen-1
								nct1=0
							elif(nct>founds+slen):
								#print("\n\t分支2-1-4中运算串后numtt：",numtt)						
								if(numt1id[1]==0) :#运算符后时，检查“数２串”栈
									#print("\n\t分支2-1-4-1中数2串压栈")	
									#if(IsNumber(numtt)):
										#print("\n\t分支2-1-4-1-1中运算串后有数")						
									numt1[1]=numtt#压栈列表第2格
									numt1[4]=lstr[nct:]#压栈列表第5格
									numt1id[1]=1#标记有“数1串”
									numt1id[4]=1#标记有“后串”
								elif(numt1id[3]==0) :#运算符后时，检查“数２串”栈
									#print("\n\t分支2-1-4-1中数2串压栈")	
									#if(self.IsNumber(numtt)):
										#print("\n\t分支2-1-4-1-1中运算串后有数")						
									numt1[3]=numtt#压栈列表第4格
									numt1[4]=lstr[nct:]#压栈列表第5格
									numt1id[3]=1#标记有“运算串”
									numt1id[4]=1#标记有“后串”
								#print("\n\t分支2-1-4列表numt1：",numt1)
								#print("\n\t分支2-1-4列表numt1id：",numt1id)
								break	
					else:#分割串数字时5
			#			print("\t分支２－２为非数转数字状态")
						if(nct == 0):#首字时
							numt=strnl
#							print("\n\t分支2-2-1首字串numt：",numt,"\tnct1=",nct1)
							nct1+=1#设置变化位置
						else:#非首字时5
	#						numtt=numt
	#						numt=strnl
							if (nct == (xlen-1)):#末字时
			#					print("\n\t分支2-2-2末字串numt：",numt,"\t串长nct1=",nct1,"\tnumtt=",numtt)
								if(numt1id[2]==0):#"运算串"栈空时，压栈实际分隔串
									numt1[2]=numtt#列表第3格记录运算串
									numt1id[2]=1#标记"运算串"
								elif(numt1[2]!=symb):#0603numtt):#检查实际分隔串与"运算串"不同时清空退出
			#						print("\n\t分支2-2-2-1实际分隔运算串[",numtt,"]与运算符[",symb,"]不同，处理清除")
									numt1id=[0,0,0,0,0]
									break	
								if(numt1id[1]==0):
									numt1[1]=numt#列表第2格记录"数1"串
									numt1id[1]=1#标记"数1"
								else:
									numt1[3]=numt#列表第4格记录"数2"串
									numt1id[3]=1#标记"数2"
								nct1+=1#0603
							elif(nct==founds) :#运算符时
#								print("\n\t分支2-2-3中运算串numtt：",numtt)						
								if(numtt==symb):#判断是"运算串"
#									print("\n\t分支2-2-3-1是运算串！")						
									if(numt1id[2]==0):#“运算串”栈空时
#										print("\n\t分支2-2-3-1-1运算串空 ，压栈")						
										numt1[2]=numtt#压栈列表第2格
										numt1id[2]=1#标记有“运算串”
									else:#“运算串”满时,压入后串栈
#										print("\n\t分支2-2-3-1-1运算串满，压入后串退出！")						
										numt1[4]=lstr[nct-1:]#列表第5格记录后串
										numt1id[4]=1#标记有“后串”
										nct=xlen#退出
								else:#判断非"运算串"
#									print("\n\t分支2-2-3-2非运算串！")						
									if(numt1id[0]==0):#“前串”栈空时，压栈
										numt1[0]=numtt#列表第3格记录“前串”
										numt1id[0]=1#标记有“前串”
							elif(nct==founds+slen+1):#v0.969(nct>founds+slen):
				#				print("\n\t分支2-2-４中运算串后numtt：",numtt)						
								if(numt1id[3]==0) :#运算符后时，检查“数２串”栈
									if(self.IsNumber(numtt)):
#										print("\n\t分支2-2-4-1中运算串后有数")						
										numt1[3]=numtt#压栈列表第2格
										numt1[4]=lstr[nct]#压栈列表第5格
										numt1id[3]=1#标记有“数２串”
										numt1id[4]=1#标记有“后串”
									else:	
#										print("\n\t分支2-2-4-2中运算串后无数")						
										numt1[4]=lstr[nct-len(numtt)]#压栈列表第5格
										numt1id[4]=1#标记有“后串”
								break	
							elif(nct>founds+slen+1):
								if(numt1id[2]==1):
									if(numt1[2]!=numtt):
					#					print("\n\t分支2-2-5中实际分隔运算串[",numtt,"]不同于运算符[",symb,"]处理清除")
										numt1id=[0,0,0,0,0]
										break	
	
#				print("\n字串栈：",numt1)
#				print("\n字串栈标记：",numt1id)
								
				nct+=1
				strt = strnl
				statet =state 
			loclist.append(numt1id)
			loclist.append(numt1)
	#	print("\n输出五位栈表：",loclist)
		return loclist
	
	def build(self):
		return RV()



	def RunUp(self):#	slot_btn_openFile (self):#显示上栏文件20230203
#		print("\n进入slot_btn_openfile->")
		self.selectedItem=SelectableButton.selectedItem 
		lnum=self.selectedItem#self.OnOpNumber()
		print("RunUp点中行：",lnum)
		if lnum<=0:
			self.ListFileOpen()#slot_btn_chooseFile()
		else:
#			self.Diary()#0404
			self.openlabfile()



# 11 29           (5748)
	def  openlabfile(self):#显示库文件(labfile)
		fh=False
		mypath=os.path.join(os.getcwd(),self.OftenFiles)
		fh1=open(mypath,mode='r',encoding='UTF-8')
		if fh1:
			data=fh1.read()
			filelist=data.split("\n")
			fh1.close() #20230219
		i=0#self.model.item(0).checkState()#检测顶行是否勾选，决定是之后文件格式行显示否
		#print("\n\t检测顶行勾选与否：",i)
		if(i>0):
			self.FormatShow=True#格式行显示
			#print("\n\t格式行显示开关打开",self.FormatShow)
		else:
			self.FormatShow=False#格式行不显示
			#print("\n\t格式行显示开关关闭",self.FormatShow)

		i=self.selectedItem#OnOpNumber()#v0.76
		if (i<=0):
			slecstr=mypath
		else:
			print("\n\ti>0,i=",i)
			if(filelist):
				slecstr=os.path.join(os.getcwd(),"src",filelist[i-1])
		self.fileName_choose=slecstr
		print("\n当前打开文件self.fileName_choose名： ",self.fileName_choose)
		self.prompstr="" #slecstr v0.76
		self.myfileopen(slecstr,1)

	#def	slot_btn_chooseFile (self):#库文件操作
	def ListFileLoad(self,path,filename):#):#库文件操作
#		print("选择方法中全局文件名为:",self.fileName_choose)#测试全局变量
		if self.fileName_choose.strip():#打开的非库文件
			filet=self.fileName_choose
#		self.fileName_choose,filetype = QFileDialog.getOpenFileName(self,#kv0611
#									"选择库文件或在列文件可以实际更新",
#									self.cwd,# 起始路径 
#									"All Files (*);;Setfiles(*.set);;Pthon Files (*.py);;Text Files (*.txt);;向导文件(*.xdf)")# 设置文件扩展名过滤,用双分号间隔
		mypath=os.path.join(os.getcwd(),self.OftenFiles)
		mylist1=[]
		lnum=self.selectedItem #kv OnOpNumber()
		if lnum<0:#此句为后加，限制了其它功能
			lnum=0
		print("常用文件路径：",mypath,"当前操作lnum=",lnum,"行")
	#	QMessageBox.setStyleSheet(self,"border-image:url(sty/cloud.png)")###0423
		fh=open(mypath,mode='a+t',encoding='UTF-8')
		if fh:
			fh.seek(0)#注意读取文件时候要将文件指针指向第一个
			data=fh.read()
			mylist = data.split("\n")
#			print("完成打开文件，准备读取->",mypath,"。文件字符:\n",data,"转列表为：\n",mylist)
			if os.path.basename(self.fileName_choose) not in mylist:
				if(os.path.basename(self.fileName_choose) == os.path.basename(mypath)):
#					print ("你选择了文件库目录本身，不能写入，但列表框内的字符将被更新！")
	#				reply = QMessageBox.information(self,"文库目录更新提示", "文件："+self.fileName_choose+" 为文库设置文件，你要更新吗？",QMessageBox.Yes | QMessageBox.No)#使用infomation信息框v0.62
					self.QtMessageOk = False#kv0611
					self.InfoPop("文库目录更新提示", "文件："+self.fileName_choose+" 为文库设置文件，你要更新吗？")
					if(self.QtMessageOk):#kvk0611(reply==QMessageBox.Yes):
						for i in range(1,self.model.rowCount()):
							mylist1.append(self.model.item(i).index().data())#获取字符
						self.WLinetoFile(mylist1,mypath,-1)
				else:
#					print ("文件名不在目录列表内,当前选中第",lnum,"行，在其后插入（默认首行0）：")
	#				reply = QMessageBox.information(self,"文库目录添加提示", "文件："+self.fileName_choose+" 尚未在文库目录，你确定添加吗？", QMessageBox.Yes | QMessageBox.No)  
					self.QtMessageOk = False#kv0611
					self.InfoPop("文库目录添加提示", "文件："+self.fileName_choose+" 尚未在文库目录，你确定添加吗？")
					if(self.QtMessageOk):#kvk0611(reply==QMessageBox.Yes):
						lstr=os.path.split(self.fileName_choose)[1]
						self.AddItemView(lnum,lstr)
						self.WLinetoFile(mylist,mypath,lnum)
			else:
#				print ("\n\t文件名已在列表内，不进行添加，但正好为列表显示文件时，更新写入列表字符。")
				if(self.fileName_choose==filet):
					if(self.Expfnow==0):#全览模式下保存
						#reply = QMessageBox.information(self,"文件覆盖提示", "文件："+self.fileName_choose+" 将被重写覆盖，你确定吗？",QMessageBox.Yes | QMessageBox.No)  
						#if(reply==QMessageBox.Yes):
						self.QtMessageOk = False#kv0611
						self.InfoPop("覆盖提示", "文件："+self.fileName_choose+" 将被重写覆盖，你确定吗？")
					if(self.QtMessageOk):#kvk0611(reply==QMessageBox.Yes):
							self.WListtoFile(mylist,self.fileName_choose)
					else:#分页模式下保存
						#reply = QMessageBox.information(self,"文件覆盖提示", "文件["+self.fileName_choose+"]正在分页模式下操作，如果保存将只更新本页字符，你确定吗？",QMessageBox.Yes | QMessageBox.No)  
						#if(reply==QMessageBox.Yes):
						self.QtMessageOk = False#kv0611
						self.InfoPop("文件覆盖提示", "文件["+self.fileName_choose+"]正在分页模式下操作，如果保存将只更新本页字符，你确定吗？")
					if(self.QtMessageOk):#kvk0611(reply==QMessageBox.Yes):
							self.UpPagetoFile(self.fileName_choose)
			fh.close()
	#	self.setStyleSheet("border-image:url(sty/palace.png)")
#		self.ui.show()
#		self.show()



	def AddItemView (self,lnum,lstr):#顶行添至点选行后
#		print("进入AddItemView")
		mylist=[]
		lM=len(self.Model)
		for i in range(lM):#self.model.rowCount()):
			s=self.Model[i]#self.model.item(i).index().data()#获取字符
#			print("第",i,"项：",s)
			mylist.append(s)
			if(i==lnum):#操作行时，将0行字符插入列表
#				print("插入",i+1,"项：",lstr)
				mylist.append(lstr)
		i=0
		for task in mylist:
#			item = QStandardItem(task)
#			item.setCheckState(False)
#			item.setCheckable(True)
			if i == 0 :
#				self.model.clear()
#				self.model.appendRow(item)
				self.Model=[]
				self.Model.append(item)
			else :
				self.Model.append(item)
#			self.ui.listView.setModel(self.model)
			i=i+1
		i=0
		it=len(self.Model)#self.model.rowCount()
		self.QtSetmodel(self.Model)
#		print("\tAddItem表有",it,"项")
	#	for i in range(it):
#			print("第",i,"项：")
	#		if(i<=lnum):
	#			if(i in self.CheckedRowNuber):
#					print("插入行前第",i,"行在选中表中")
	#				it=self.model.item(i)
	#				it.setData(QVariant(Qt.Checked),Qt.CheckStateRole)
	#		if(i>lnum):
	#			if(i-1 in self.CheckedRowNuber):
#					print("插入行后第",i-1,"行在选中表中")
	#				it=self.model.item(i)
	#				it.setData(QVariant(Qt.Checked),Qt.CheckStateRole)
	#		i+=1

#		self.ui.show()
#		self.show()	


		
	def WLinetoFile (self,llist,lpath,lnum):#行更新进文件###0415
	#	print("\n\t\t进入WLinetoFile模块，列表行插入文件操作，待插入的列表为：",llist)
	#	print("\t\t新行位于文件:",self.fileName_choose,"\n\t\t摘引准备写至[",lpath,"]第(",lnum,")行")
		fh1=open(lpath,mode='r+t',encoding='UTF-8')
		if fh1:
			fh1.seek(0)#读取文件时候要将文件指针指向第一个
			data=fh1.read()
			mylist = data.split("\n")#含完整的文件路径
		fh1.close()
	#	print("\t\t\t原文件元素表",mylist)
		if(lnum==0):#0415 >=0
			mylist.insert(lnum,self.fileName_choose)#0413
#			print("[",lstr,"]插入列表(",lnum,")项")
		elif(lnum>0):
			for lstr in llist:
				mylist.insert(lnum,lstr)
				lnum+=1
	#		print("列表成为",mylist)
		fh1=open(lpath,mode='w+t',encoding='UTF-8')
		if fh1:
			fh1.seek(0)
			for i in range(len(mylist)-1):#0414len(mylist)
	#			if mylist[i]:#0413.strip()
#					print("准备将第",i,"项写入文件：",lpath)
				fh1.write(mylist[i]+'\n')
			fh1.write(mylist[len(mylist)-1])
			fh1.close()
		if(lnum<0):#else:#根据删除、拖放更新文件列表
			fh1=open(lpath,mode='w+t',encoding='UTF-8')
			if fh1:
				fh1.seek(0)
				for i in range(len(llist)):
					for i1 in range(len(mylist)):
						if(llist[i].strip()):
							lstr=os.path.split(mylist[i1])[1]
							if(llist[i]==lstr):
#								print("第",i,"项：",llist[i],"-->对应完整路径：",mylist[i1],"写入")#此法不能删除某一同名文件
								fh1.write(mylist[i1]+'\n')
								break
#							else:
#								print(lstr,"非对应路径，不予写入文件：",lpath)

			fh1.close()



	def UpPagetoFile (self,lpath):#本页列表更新进文件
		print("进入更新本页至文件操作，文件:",self.fileName_choose,"\n\t准备压栈至：",lpath)
		fh1=open(lpath,mode='w+t',encoding='UTF-8')
		if fh1:
			fh1.seek(0)
			for i in range(self.Expbnow):
				fh1.write(self.ViewList[i]+'\n')
			for i in range(self.model.rowCount()):
				s=self.model.item(i).index().data()#获取字符
				if(i==0 and (not s.strip())):
					fh1.write(self.ViewList[self.Expbnow]+'\n')
				else:
					fh1.write(s+'\n')
			for i in range(self.Expfnow,self.lViewList-1):
				fh1.write(self.ViewList[i]+'\n')
			fh1.write(self.ViewList[i])
			fh1.close()
		fh1=open(lpath,mode='r+t',encoding='UTF-8')###0421
		if fh1:
			data=fh1.read()
			mylist=self.PJList(data.split("\n"))
			fh1.close()
		lm=len(mylist)
		fh1=open(lpath,mode='w+t',encoding='UTF-8')
		if fh1:
			for i in range(lm-1):
				fh1.write(mylist[i]+'\n')
			fh1.write(mylist[lm-1])
			fh1.close()



	def InfoPop(self,TitleString,InfoString):
		popup = EditStatePopup(self)
		self.ids['EditStatePopup'].ids['Pop_Title'].text=TitleString
		self.ids['EditStatePopup'].ids['Pop_Info'].text=InfoString
		popup.open()

	def InfOk(self):
		self.QtMessageOk = True

if __name__ == '__main__':
	MainApp().run()
 
